
/* MOD-1   	Oct 88	*/ 
/* Modified so that during image transfer characters between 128 and 160
*  would not be quoted.  Quoting takes two bytes rather than one byte and 
*  doubles transmission time.  The only characters quotes are pure control
*  characters, quote (#) , and DEL.  Even with packed files, this allows for
*  fairly efficient transmission.

*  The only characters quoted are true control characters 0-31 (decimal),
*  the DEL (127) and the quote itself '#'.  *  This is to prevent side 
*  effects - especially  XON/XOFF is on.
*  Binary transmission occurs rapidly when using image mode.  This transmits
*  full 8 bits.  RAW mode on both ends this allows 8 bit transmission.  

*  Some systems interpret hex 93 ( ' XOFF - quoted DC3 ) as XOFF and actually
*  stop transmission.  This is now quoted.  Both XOFF and XON had
*  to be quoted.  This added 4/7/90 - sws
*/

/* MOD-2 */
/* Modified to write only 7 character ascii characters to screen in
*  connect mode.  On systems generating parity would cause havoc.
*  Better way is to insure -istrip is turned on in terminal mode.
*/

/* MOD-3 */
/* Debugging output made more palatable and easier to decipher.  More
*  information per line.  Previously would scroll by too fast.
*  Now sends dot '.' for each packet sent or received.  If not a data
*  packet, puts the type of packet.
*  added character count output to debug to see how many characters received
*  and in what order.
*
/* MOD-4  Jan 90
*  Improved gnextfil - which user doesn't understand.
*  Made the debug level 1 message print out "Next file: xxx" if and only
*  if another file exits.  Previously this was confusing.
*/


/* MOD-5 Jan 90
*  Show "%" when request for retransmition of data occurs
*/

/* MOD-6 Jan 90                       (Jan 19, 1990)
*  Put terminal io routines into system independent calls:
*  rawmode(), origmode(), and setspeed()
*  these routines are defined for UXIII - System III or V Xenix/Unix
*  or UCB4X - Berkley BSD versions - using the sgtty.h conventions
*  Made code compile compatible with Xenix 3.0 also ( -DUXIII )
*/

/*  4/21/89
	Clarification of TANDEM
		some versions of sggty.h do not support the TANDEM flag
		on these versions TANDEM will not be defined and the compiler
		will notify you of this.
		This code has been changed to handle this case.
		If this is a problem compile using:
		-DTANDEM=0

		In SCO XENIX TANDEM is defined to be 01
		TANDEM enables XON/XOFF handshaking
*/

 
/* This source does not include the features of data compression,
extended packet lengths, variable packet size adjustements based on
line noise, and variable receiver timeout */

#include <stdio.h>	    
#include <fcntl.h>
#define COMDIR "/usr/cactus/jetcom/"
#define YES 1
#define NO  0
#define MAX_TTYS    20   


#define UXIII       1   
#define UCB4X	    0	    
#define TOPS_20	    0	    
#define IBM_UTS	    0	    
#define VAX_VMS	    0	    
#if UCB4X
#define V6_LIBS	    0	    
#define NO_FIONREAD 1	    
#define NO_TANDEM   0	    
#endif
#if IBM_UTS
#define V6_LIBS	    0	    
#define NO_FIONREAD 1	    
#define NO_TANDEM   1	    
#endif
#if V6_LIBS
#include <retrofit/sgtty.h>
#include <retrofit/signal.h>
#include <retrofit/setjmp.h>
#endif
#if UXIII
#include <sys/types.h>
#include <sys/ioctl.h>
#include <termio.h>
#include <signal.h>
#include <setjmp.h>
#else
#include <sgtty.h>
#include <signal.h>
#include <setjmp.h>
#endif
#if NO_TANDEM
#define TANDEM	    0	    
#endif
#ifndef TANDEM
#define TANDEM 0
#endif
#define MAXPACKSIZ  94	    
#define SOH	    1	    
#define CR	    13	    
#define SP	    32	    
#define DEL	    127	    
#define XON     17
#define XOFF    19

#define ESCCHR	    '^'	    
#define MAXTRY	    8	    
#define MYQUOTE	    '#'	    
#define MYPAD	    0	    
#define MYPCHAR	    0       

#if IBM_UTS
#define MYEOL	    '\r'    
#else
#define MYEOL	    '\n'    
#endif
#define MYTIME	    5	    
#define MAXTIM	    60	    
#define MINTIM	    2	    
#define TRUE	    -1	    
#define FALSE	    0
#define tochar(ch)  ((ch) + ' ')
#define unchar(ch)  ((ch) - ' ')
#define ctl(ch)	    ((ch) ^ 64 )
char * scid = "	 @(#)kermit.c	1.2		12/1/90";
static char * rev = "	@(#)Revision	1.1	12/1/90 ";

char parity = 'n';  

int	size, 		    
rpsiz, 		    
spsiz, 		    
pad, 		    
timint, 		    
n, 		    
numtry, 		    
oldtry, 		    
ttyfd, 		    
remote, 		    
image, 		    
debug, 		    
filnamcnv, 	    
filecount;
char	state, 		    
padchar, 	    
eol, 		    
escchr, 		    
quote, 		    
**filelist, 	    
*filnam, 	    
recpkt[MAXPACKSIZ], 
packet[MAXPACKSIZ];
#define QUICK  
int cflg, rflg, sflg;
long tm_start, tm_finish, tm_elapsed, filesize;
#include <sys/stat.h>
struct stat statbuf;
int donothing() {}
extern int cleanup();
jmp_buf env;



FILE	*fp, 		    
*log;
main(argc, argv)
int	argc;
char	**argv;
{
	char	*ttyname, 			
	*cp;
	int status=0;
	int	speed; 				
	if (argc < 2) 
		usage();
	cp = *++argv; 
	argv++; 
	argc -= 2;
	eol = CR;
	quote = '#';
	pad = MYPAD;
	padchar = MYPCHAR;
	speed = cflg = sflg = rflg = 0;
	ttyname = 0;
#if UXIII || UCB4X				
	image = FALSE;
	filnamcnv = TRUE;
	signal(SIGTERM,cleanup);
	signal(SIGINT,cleanup);
	signal(SIGQUIT,cleanup);
#else
	image = TRUE;
	filnamcnv = FALSE;
#endif
	escchr = ESCCHR;

	while ((*cp) != '\0')
		switch (*cp++) {
		case 'c': 
			cflg++; 
			break;
		case 's': 
			sflg++; 
			break;
		case 'r': 
			rflg++; 
			break;
		case 'd':
			debug++; 
			break;

		case 'f':
			filnamcnv = FALSE;
			break;
		case 'i':
			image = TRUE; 
			break;
		case 'l':
			if (argc--) 
				ttyname = *argv++;
			else 
				usage();
			if (debug) 
				printf("Line to remote host is %s\n", ttyname);
			break;

		case 'e':
			if (argc--) 
				escchr = **argv++;
			else 
				usage();
			if (debug) 
				printf("Escape char is \"%c\"\n", escchr);
			break;

		case 'b':
#ifndef NONUNIX
			if (argc--) 
				speed = atoi(*argv++);
			else 
				usage();
			if (debug) 
				printf("Line speed to remote host is %d\n", speed);
			break;
#else
			printmsg("Speed setting implemented for Unix only.");
			exit(1);
#endif
		case 'p':  
			if(argc--)
				parity = *argv[0];  
			printf("Using Parity set to %s\n\r", *argv);
			argv++;
			break;
		}
	if ((cflg + sflg + rflg) != 1)
		usage();
	if (ttyname) {
		signal(SIGALRM,donothing); 
		alarm(2);
		ttyfd = open(ttyname, 2);
		if (ttyfd < 0) {
			printmsg("Cannot open %s", ttyname);
			exit(1);
		}
		alarm(0);
		remote = FALSE;
	} else    {
		ttyfd = sflg?1:0;  
		remote = TRUE;
	}
	rawmode(ttyfd,parity);

	if(ttyname) {
		if (speed) {
			int bspeed;
			switch (speed) {
			case 110: bspeed = B110; break;
			case 150: bspeed = B150; break;
			case 300: bspeed = B300; break;
			case 1200: bspeed = B1200; break;
			case 2400: bspeed = B2400; break;
			case 4800: bspeed = B4800; break;
			case 9600: bspeed = B9600; break;
			case 19200: bspeed = EXTA; break;
			case 38400: bspeed = EXTB; break;  
			default:
				printmsg("Bad line speed.");
				exit(1);
			}
			setspeed(ttyfd,bspeed);
			if(speed <= 2400)
				handshake(ttyfd,NO);  
		}
	}
	if (debug) {
		printf("Debugging level = %d\n\n", debug);
		if (cflg) 
			printf("Connect command\n\n");
		if (sflg) 
			printf("Send command\n\n");
		if (rflg) 
			printf("Receive command\n\n");
	}

	if (cflg) {
		handshake(ttyfd,NO);
		connect();
	}
	if (sflg) {
		if (argc--) 
			filnam = *argv++;
		else
		 {   
			if (remote)
				origmode(0);
			usage();
		}
		fp = NULL;
		filelist = argv;
			filecount = argc;
		if (sendsw() == FALSE){
			printmsg("Send failed.");
			status = 1;
		}
		else
			printmsg("done.");
	}
	if (rflg) {
		if (recsw() == FALSE){
			printmsg("Receive failed.");
			status = 1;
		}
		else
			printmsg("done.");
	}
	origmode(ttyfd);  
	exit(status);
}


sendsw()
{
	char	sinit(), sfile(), sdata(), seof(), sbreak();
	state = 'S';
	n = 0;
	numtry = 0;
	while (TRUE) {

		if (debug) {  
			printf("%c", (state == 'D' ? '.' : state));
			fflush(stdout);
		}
		switch (state) {
		case 'S':	
			state = sinit();  
			break;
		case 'F':	
			state = sfile();  
			time(&tm_start);
			break;
		case 'D':	
			state = sdata();  
			break;
		case 'Z':	
			state = seof();	  
			break;
		case 'B':	
			state = sbreak(); 
			break;
		case 'C':	
			return (TRUE);
		case 'A':	
			return (FALSE);
		default:	
			return (FALSE);
		}
	}
}


char	sinit()
{
	int	num, len;
	if (numtry++ > MAXTRY) 
		return('A');
	spar(packet);
	flushinput();
	spack('S', n, 6, packet);
	switch (rpack(&len, &num, recpkt)) {
	case 'N':  
		return(state);
	case 'Y':
		if (n != num)
			return(state);
		rpar(recpkt);
		if (eol == 0) 
			eol = '\n';
		if (quote == 0) 
			quote = '#';
		numtry = 0;
		n = (n + 1) % 64;
		return('F');
	case 'E':
		prerrpkt(recpkt);
		return('A');
	case FALSE: 
		return(state);
	default: 
		return('A');
	}
}


char	sfile()
{
	int	num, len;
	char	filnam1[50], 			
	*newfilnam, 			
	*cp;
	if (numtry++ > MAXTRY) 
		return('A');

	if (fp == NULL) {	
		if (debug>1) 
			printf("\nOpening %s for sending ", filnam);
		if(strcmp(filnam,"-") == 0)
			fp = stdin;
		else
			fp = fopen(filnam, "r");
		if (fp == NULL) {
			error("Cannot open file %s", filnam);
			return('A');
		}
	}
	strcpy(filnam1, filnam);
	newfilnam = cp = filnam1;
	while (*cp != '\0')
		if (*cp++ == '/')
			newfilnam = cp;
	if (filnamcnv)
		for (cp = newfilnam; *cp != '\0'; cp++)
			if (*cp >= 'a' && *cp <= 'z')
				*cp ^= 040;
	len = cp - newfilnam;
	stat(filnam,&statbuf);
	filesize = statbuf.st_size;
	printmsg("Sending %s as %s\tSize: %ld bytes", filnam, newfilnam,filesize);
	spack('F', n, len, newfilnam);
	switch (rpack(&len, &num, recpkt)) {
	case 'N':
		num = (--num < 0 ? 63 : num);
		if (n != num)
			return(state);
	case 'Y':
		if (n != num) 
			return(state);
		numtry = 0;
		n = (n + 1) % 64;
		size = bufill(packet);
		return('D');
	case 'E':
		prerrpkt(recpkt);
		return('A');
	case FALSE: 
		return(state);
	default:    
		return('A');
	}
}


char	sdata()
{
	int	num, len;
	if (numtry++ > MAXTRY) 
		return('A');
	spack('D', n, size, packet);
	switch (rpack(&len, &num, recpkt)) {
	case 'N':
		num = (--num < 0 ? 63 : num);
		if(debug)
			printf("%%");   
		if (n != num)
			return(state);
		

	case 'Y':
		if (n != num) {
			if(debug)
				printf("%%");   
			return(state);
		}
		numtry = 0;
		n = (n + 1) % 64;
		if ((size = bufill(packet)) == EOF)
			return('Z');
		return('D');
	case 'E':
		prerrpkt(recpkt);
		return('A');
	case FALSE: 
		return(state);
	default:    
		return('A');
	}
}


char	seof()
{
	int	num, len;
	if (numtry++ > MAXTRY) 
		return('A');
	spack('Z', n, 0, packet);
	switch (rpack(&len, &num, recpkt)) {
	case 'N':
		num = (--num < 0 ? 63 : num);
		if (n != num)
			return(state);
	case 'Y':
		if (n != num) 
			return(state);
		numtry = 0;
		n = (n + 1) % 64;
		time(&tm_finish);
		if( (tm_elapsed = tm_finish - tm_start) == 0)
			tm_elapsed = 1;  
		if (debug) {
			printf(" Speed: %ld baud\n\r", (filesize * 10)/ tm_elapsed );
		}
		fclose(fp);
		fp = NULL;
		if (gnxtfl() == FALSE)
			return('B');
		return('F');
	case 'E':
		prerrpkt(recpkt);
		return('A');
	case FALSE: 
		return(state);
	default:    
		return('A');
	}
}


char	sbreak()
{
	int	num, len;
	if (numtry++ > MAXTRY) 
		return('A');
	spack('B', n, 0, packet);
	switch (rpack(&len, &num, recpkt)) {
	case 'N':
		num = (--num < 0 ? 63 : num);
		if (n != num)
			return(state);
	case 'Y':
		if (n != num) 
			return(state);
		numtry = 0;
		n = (n + 1) % 64;
		return('C');
	case 'E':
		prerrpkt(recpkt);
		return('A');
	case FALSE: 
		return(state);
	default:    
		return ('A');
	}
}


recsw()
{
	char	rinit(), rfile(), rdata();
	state = 'R';
	n = 0;
	numtry = 0;
	while (TRUE) {

		if (debug) { 
			printf("%c", (state == 'D' ? '.' : state));
			fflush(stdout);
		}
		switch (state) {
		case 'R':	
			state = rinit(); 
			break;
		case 'F':	
			state = rfile(); 
			break;
		case 'D':	
			state = rdata(); 
			break;
		case 'C':	
			return(TRUE);
		case 'A':	
			return(FALSE);
		default:    
			printf("\nUNKNOWN STATE: %c\n", state);
			state = rdata();
			break;
		}
	}
}




char	rinit()
{
	int	len, num;
	if (numtry++ > MAXTRY) 
		return('A');
	switch (rpack(&len, &num, packet)) {
	case 'S':
		rpar(packet);
		spar(packet);
		spack('Y', n, 6, packet);
		oldtry = numtry;
		numtry = 0;
		n = (n + 1) % 64;
		return('F');
	case 'E':
		prerrpkt(recpkt);
		return('A');
	case FALSE:
		spack('N', n, 0, 0);
		return(state);
	default:     
		return('A');
	}
}


char	rfile()
{
	int	num, len;
	char	filnam1[50];
	if (numtry++ > MAXTRY) 
		return('A');
	switch (rpack(&len, &num, packet)) {
	case 'S':
		if (oldtry++ > MAXTRY) 
			return('A');
		if (num == ((n == 0) ? 63 : n - 1)) {
			spar(packet);
			spack('Y', num, 6, packet);
			numtry = 0;
			return(state);
		} else 
			return('A');
	case 'Z':
		if (oldtry++ > MAXTRY) 
			return('A');
		if (num == ((n == 0) ? 63 : n - 1)) {
			spack('Y', num, 0, 0);
			numtry = 0;
			return(state);
		} else 
			return('A');
	case 'F':
		if (num != n) 
			return('A');
		strcpy(filnam1, packet);
		if (filnamcnv)
			for (filnam = filnam1; *filnam != '\0'; filnam++)
				if (*filnam >= 'A' && *filnam <= 'Z')
					*filnam |= 040;
		if ((fp = fopen(filnam1, "w")) == NULL) {
			error("Cannot create %s", filnam1);
			return('A');
		} else
			printmsg("Receiving %s as %s", packet, filnam1);
		spack('Y', n, 0, 0);
		oldtry = numtry;
		numtry = 0;
		n = (n + 1) % 64;
		return('D');
	case 'B':
		if (num != n) 
			return ('A');
		spack('Y', n, 0, 0);
		return('C');
	case 'E':
		prerrpkt(recpkt);
		return('A');
	case FALSE:
		spack('N', n, 0, 0);
		return(state);
	default:    
		return ('A');
	}
}


char	rdata()
{
	int	num, len;
	if (numtry++ > MAXTRY) 
		return('A');
	switch (rpack(&len, &num, packet)) {
	case 'D':
		if (num != n) {
			if (oldtry++ > MAXTRY)
				return('A');
			if (num == ((n == 0) ? 63 : n - 1)) {
				if(debug) printf("%%");  
				spack('Y', num, 6, packet);
				numtry = 0;
				return(state);
			} else 
				return('A');
		}

		bufemp(packet, len);
		spack('Y', n, 0, 0);
		oldtry = numtry;
		numtry = 0;
		n = (n + 1) % 64;
		return('D');
	case 'F':
		if (oldtry++ > MAXTRY)
			return('A');
		if (num == ((n == 0) ? 63 : n - 1)) {
			spack('Y', num, 0, 0);
			numtry = 0;
			return(state);
		} else 
			return('A');
	case 'Z':
		if (num != n) 
			return('A');
		spack('Y', n, 0, 0);
		fclose(fp);
		n = (n + 1) % 64;
		return('F');
	case 'E':
		prerrpkt(recpkt);
		return('A');
	case FALSE:
		spack('N', n, 0, 0);
		return(state);
	default:     
		return('A');
	}
}


connect()
{
	int	pid, 				
	connected;
	char	bel = '\07',
	c, c7;
	char  compath[100];
	static char hotkey[10];
	if (remote) {
		printmsg("No line specified for connection.");
		return;
	}
	rawmode(0,'u');  
	
	pid = fork();
	if (pid) {
		int fd;
		int cc;
		int i;
		int disconnect = FALSE;
		int n;
		static char spbuf[30];
		printmsg("connected...");
		gethotpath(compath);
		if((fd = open(compath, O_RDONLY)) < 0) {
			printmsg("Cannot determine HOTKEY from %s\n\r"
			"Using default of '%cc'",compath, escchr);
			hotkey[0] = escchr;
			hotkey[1] = 'c';
			cc = 2;
		} else {
			cc = read(fd,hotkey,10);
			spbuf[0] = hotkey[0];
			hotkey[cc] = (char) 0;
		}

		connected = TRUE;
		while (connected) {
			read(0, &c, 1); 
			c7 = c & 0177;
			if (c7 == hotkey[0]) {
				disconnect = TRUE;
				n = read(0, &spbuf[1], cc-1);  
				for(i=1; i <cc; i++){
					if((spbuf[i] & 0177) != hotkey[i]){
						disconnect=FALSE;
						write(ttyfd, &spbuf[0], n+1);
						break;
					}
				}
				if( disconnect == TRUE) 
					connected = FALSE;
				
				continue;
			} 
			if (c7 == escchr)	
			{ 
				read(0,&c,1);
				switch(c&0177) {
					case 'c':
					case 'C':
						connected = FALSE;
						continue;
#ifdef  TCSBRK  
					case 'b':
					case 'B':
						printmsg("Sending BREAK");
						ioctl(ttyfd,TCSBRK,0);
						break;
#endif
					default:
						write(ttyfd, &escchr,1);
				}
			}
			write(ttyfd, &c, 1); 
			c = 0;
		}
		kill(pid, 9);
		wait(0);
		origmode(0);
		printmsg("disconnected.");
		return;
	} else    {
		while (1) {
			read(ttyfd, &c, 1);
			if(image == FALSE) 
				c &= 0177;     
			write(1, &c, 1);
		}
	}
}

#ifdef _JBLEN
clkint()
{

	signal(SIGALRM, clkint);
	if (debug) {
		printf("\nTIMEOUT: No valid packets in %d seconds...continuing\n", timint);
		fflush(stdout);
	}
	longjmp(env, TRUE);
}
#endif


spack(type, num, len, data)
char	type, *data;
int	num, len;
{
	int	i;
	char	chksum, buffer[MAXPACKSIZ + 10];
	register char	*bufp;
	if (debug > 1) 
		printf("\nSEND PACK TYPE: %c\tNUM: %d\tLENGTH: %d\n", type, num, len);
	if (debug > 2) {
		if (data != NULL) {
			data[len] = '\0';
			printf("\nSDATA:\"%s\"\n", data);
		}
	}

	bufp = buffer;
	*bufp++ = SOH;
	*bufp++ = tochar(len + 3);
	chksum  = tochar(len + 3);
	*bufp++ = tochar(num);
	chksum += tochar(num);
	*bufp++ = type;
	chksum += type;
	for (i = 0; i < len; i++) {
		*bufp++ = data[i];
		chksum += data[i];
	}
	chksum = (((chksum & 0300) >> 6) + chksum) & 077;
	*bufp++ = tochar(chksum);
	*bufp = eol;
	for (i = 1; i <= pad; i++) 
		write(ttyfd, &padchar, 1);
	write(ttyfd, buffer, bufp - buffer + 1);
}


rpack(len, num, data)
int	*len, *num;
char	*data;
{
	int	i, done;
	int	count = 0;
	char	t, 				
	type, 				
	cchksum, 			
	rchksum;
#ifdef _JBLEN 
	if (setjmp(env)) {
		if (debug > 1 ) {
			printf("LAST READ VALUE: %d  \tCOUNT: %d\n", t, count);
			fflush(stdout);
			return(FALSE);
		}
		return(FALSE);
	}
	signal(SIGALRM, clkint);
	if ((timint > MAXTIM) || (timint < MINTIM)) 
		timint = MYTIME;
	alarm(timint);
#endif 
	if (debug > 1)
		printf("READING PORT FOR PACKET\n");
	
	while (t != SOH) {
		read(ttyfd, &t, 1);
		t &= 0177;
		count++;
	}
	done = FALSE;
	while (!done) {
		fflush(stdout);
		if (debug > 1) {
			printf("\nSOH:%d->", count);
			fflush(stdout);
		}
		read(ttyfd, &t, 1);
		count++;
		if (!image) 
			t &= 0177;
		if (debug > 1) 
			printf("[%d]",t);
		if (t == SOH) 
			continue;
		cchksum = t;
		*len = unchar(t) - 3;
		if( *len < 0 )
			continue;
		if (debug > 1) 
			printf("Len:%d",*len);
		read(ttyfd, &t, 1);
		if (!image) 
			t &= 0177;
		if (t == SOH) 
			continue;
		cchksum = cchksum + t;
		*num = unchar(t);
		if (debug > 1) {
			printf("Num:%d",*num);
			fflush(stdout);
		}
		read(ttyfd, &t, 1);
		if (!image) 
			t &= 0177;
		if (t == SOH) 
			continue;
		cchksum = cchksum + t;
		type = t;
		if (debug > 1) {
			printf("Type:%c",type);
			fflush(stdout);
		}
		for (i = 0; i < *len; i++) {
			read(ttyfd, &t, 1);
			if (!image) 
				t &= 0177;
			if (t == SOH) 
				continue;
			cchksum = cchksum + t;
			data[i] = t;
			if (debug > 1) {
				if(t == quote)
					printf("%c",quote);
				else
					printf("_");
				fflush(stdout);
			}
		}
		data[*len] = 0;
		read(ttyfd, &t, 1);
		rchksum = unchar(t);
		if (debug > 1) {
			printf("[rchksum:%d]",rchksum);
		}
		
		read(ttyfd, &t, 1);
		if (!image) 
			t &= 0177;
		if (debug > 1) {
			if(t == eol)
				printf("<EOL>\n");
			else
			if(t == SOH ) 
				printf("<Trailing SOH!>\n");
			else
				printf("<%d>\n",t);
			fflush(stdout);
		}
		
		done = TRUE;
	}
#if _JBLEN
	alarm(0);
#endif
	count = 0;
	if (debug > 1) 
		printf("[calc: %d]",cchksum);
	if (debug > 1) 
		printf("\nRECEIVE TYPE: %c\tNUMBER: %d\tLENGTH: %d\n", type,*num,*len);
	if (debug > 2) {
		if (data != NULL) {
			data[*len] = '\0';
			printf("\nDATA:\"%s\"\n", data);
		}
	}
	cchksum = (((cchksum & 0300) >> 6) + cchksum) & 077;
	if (cchksum != rchksum) {
		if (debug) {
			if(debug > 1 ) 
				printf("\nChecksum Error: (calc: %d != recv: %d)",cchksum,rchksum);
			if(debug==1)
				printf("E");
			}
		fflush(stdout);
		return(FALSE);
	}
	return(type);
}





#ifdef QUICK   
#define HIGH 0x80
#define QUIT 28
#define CTRL_C 3
static char quotelist[] =
{0,SOH,CTRL_C,CR,XON,XOFF,QUIT, MYQUOTE, DEL, 
HIGH|CTRL_C, HIGH|XON, HIGH|XOFF,};
#endif


bufill(buffer)
char	buffer[];
{
	int	i;
	unsigned int	t;        
	char	t7;
	int j, needquote;
	i = 0;
	while ((t = getc(fp)) != EOF) {
		t7 = t & 0177;
#ifdef QUICK
		needquote = NO;
		for(j=0; j<sizeof(quotelist);j++)
			if(quotelist[j] == (char) t) {
				needquote = YES;
				break;
			}
		if(needquote == YES){
#else
		if (t < SP || t7 == DEL || t7 == quote || t7 == XOFF || t7 == XON 
		|| t7 == CTRL_C ) { 
		
		
#endif
			if (t == '\n' && !image) {
				buffer[i++] = quote;
				buffer[i++] = ctl('\r');
			}
			buffer[i++] = quote;
			if (t7 != quote) {
				t = ctl(t);
				t7 = ctl(t7);
			}
		}
		if (image)
			buffer[i++] = t;
		else
			buffer[i++] = t7;
		if (i >= spsiz - 8) 
			return(i);
	}
	if (i == 0) 
		return(EOF);
	return(i);
}


bufemp(buffer, len)
char	buffer[];
int	len;
{
	int	i;
	char	t;
	for (i = 0; i < len; i++) {
		t = buffer[i];
		if (t == MYQUOTE) {
			t = buffer[++i];
			if ((t & 0177) != MYQUOTE)
				t = ctl(t);
		}
		if (t == CR && !image)
			continue;
		putc(t, fp);
	}
}


gnxtfl()
{

	filnam = *(filelist++);
	if (filecount-- <= 0) 
		return FALSE;
	if (debug>1) 
		printf("\nNext file: \"%s\"\n", filnam);
	return TRUE;
}


spar(data)
char	data[];
{
	data[0] = tochar(MAXPACKSIZ);
	data[1] = tochar(MYTIME);
	data[2] = tochar(MYPAD);
	data[3] = ctl(MYPCHAR);
	data[4] = tochar(MYEOL);
	data[5] = MYQUOTE;
}


rpar(data)
char	data[];
{
	spsiz = unchar(data[0]);
	timint = unchar(data[1]);
	pad = unchar(data[2]);
	padchar = ctl(data[3]);
	eol = unchar(data[4]);
	quote = data[5];
}


#if UXIII
flushinput()
{
ioctl(0,TCFLSH,0);  
}
#else
#if UCB4X
flushinput()
{
long n = 1;
ioctl(0,TIOCFLUSH,&n);
}
#else
flushinput(){}
#endif
#endif


usage()
{
#ifndef NOUNIX 
	printf("Usage: kermit {c,s,r} [lbedfip] filenames\n");
	printf("\tuse only one of {-c: connect, -s: send, -r: receive}\n");
	printf("\t-l line\n\t-b baud\n\t-p parity {even,odd,none,unchanged}\n\t-i image mode (binary files)\n\t-f no filename conversion\n\t-d debug\n\t-e escape character \n");
	printf("\teg. kermit -riflbp /dev/tty2a 1200 even datafile.dat\n");
#else
	printf("Usage: kermit c[ile line esc.char]		 (connect mode)\n");
	printf("or:	   kermit s[difl line] file ...		 (send mode)\n");
	printf("or:	   kermit r[difl line]			 (receive mode)\n");
#endif
	exit(1);
}


printmsg(fmt, a1, a2, a3, a4, a5)
char	*fmt;
{
	if (!remote) {
		printf("\n\rKermit: ");
		printf(fmt, a1, a2, a3, a4, a5);
		printf("\n\r");
		fflush(stdout);
	}
}


error(fmt, a1, a2, a3, a4, a5)
char	*fmt;
{
	char	msg[80];
	int	len;
	if (remote) {
		sprintf(msg, fmt, a1, a2, a3, a4, a5);
		len = strlen(msg);
		spack('E', n, len, msg);
	} else
		printmsg(fmt, a1, a2, a3, a4, a5);
	return;
}


prerrpkt(msg)
char	*msg;
{
	printf("Kermit aborting with following error from remote host:\n%s\n", msg);
	return;
}

cleanup(status)
int status;
{
int i;

if(sflg|rflg)
		spack('E', n, 17, "Interupted <INTR>"); 
for(i=0; i< MAX_TTYS; i++)
	origmode(i);
exit(status);
}




#if UXIII 
struct reset {
	int changed;
	struct termio orig_mode;
	} reset[MAX_TTYS];

handshake(tty,action)   
int tty;
int action;
{
struct termio tmp;
ioctl(tty,TCGETA,&tmp);
if(action == NO)
	tmp.c_iflag  &= ~(IXANY|IXON|IXOFF);
else {
	tmp.c_iflag &= ~IXANY;
	tmp.c_iflag |= (IXON|IXOFF);
}
}

rawmode(tty,parity)
int tty;
char parity;
{
struct termio tmp;

if( (tty < MAX_TTYS ) && (reset[tty].changed == NO)) {
	ioctl(tty,TCGETA,&reset[tty].orig_mode);
	ioctl(tty,TCGETA,&tmp);
    tmp.c_iflag &= ~(IGNBRK|INLCR|IGNCR|ICRNL|IUCLC|INPCK|ISTRIP|IXANY); 
    tmp.c_iflag |= (IGNPAR|IXON|IXOFF);
	tmp.c_lflag = 0;
	tmp.c_oflag &= ~OPOST;
	switch(parity) {
		case 'o':
			tmp.c_cflag &= ~CSIZE;   
			tmp.c_cflag |= (PARENB|PARODD|CS7);
			break;
		case 'e':
			tmp.c_cflag &= ~(CSIZE|PARODD);   
			tmp.c_cflag |= (PARENB|CS7);
			break;
		case 'n':
			tmp.c_cflag &= ~(CSIZE|PARENB);   
			tmp.c_cflag |= CS8;  
			break;
		default: 
			break;
	}

	tmp.c_cc[VMIN] = 1;
	tmp.c_cc[VTIME] = 0;
	ioctl(tty,TCSETAF,&tmp);
	reset[tty].changed = YES;
}
}

origmode(tty)
int tty;
{
	
	if(reset[tty].changed == YES){
		ioctl(tty,TCSETAF,&reset[tty].orig_mode);
		reset[tty].changed = NO;
	}
}

setspeed(tty,speed)
int tty;
int speed;
{
struct termio tmp;
ioctl(tty,TCGETA,&tmp);
tmp.c_cflag &= ~CBAUD;
tmp.c_cflag |= speed;
ioctl(tty,TCSETAF,&tmp);
}
#else

struct reset {
	int changed;
	struct sgttyb orig_mode;
	} reset[MAX_TTYS];

handshake(tty,action)
int tty;
int action;
{
struct sgttyb tmp;
gtty(tty,&tmp);
if(action == NO)
	tmp.sg_flags &= ~(TANDEM);
else
	tmp.sg_flags |= (TANDEM);
stty(tty,&tmp);
}


rawmode(tty,parity)
int tty;
char parity;
{
struct sgttyb tmp;
if( (tty < MAX_TTYS ) && (reset[tty].changed == NO)) {
	gtty(tty,&reset[tty].orig_mode);
	gtty(tty,&tmp);
	tmp.sg_flags |= (RAW|TANDEM);
	tmp.sg_flags &= ~(ECHO|CRMOD);  
	switch(parity) {
		case 'o':
			tmp.sg_flags &= ~ANYP;   
			tmp.sg_flags  |= ODDP;
			break;
		case 'e':
			tmp.sg_flags &= ~ANYP;   
			tmp.sg_flags  |= EVENP;
			break;
		case 'n':
			tmp.sg_flags  &= ~ANYP;   
			break;
		default: 
			break;
	}
	stty(tty,&tmp);
	reset[tty].changed = YES;
}
}

origmode(tty)
int tty;
{
		if( reset[tty].changed == YES) {
			stty(tty,&reset[tty].orig_mode);
			reset[tty].changed = NO;
		}
}

setspeed(tty, speed)
int tty;
int speed;
{
struct sgttyb tmp;
gtty(tty,&tmp);
tmp.sg_ispeed = speed;
tmp.sg_ospeed = speed;
stty(tty,&tmp);
}
#endif


gethotpath(path)
char * path;
{
extern  char * getenv();
char * cp;

if((cp = getenv("HOME")) != NULL) {
	strcpy(path,cp);
	if(strcmp(cp,"/") == 0 )
		goto notset;  
	strcat(path,"/");
}else{
notset:
	strcpy(path,COMDIR);
}
strcat(path,".HOTKEY");
}
